#ifndef NATNET_CLIENT_H
#define NATNET_CLIENT_H

#include <nan.h>
#include <native_huron/emitter.h>

#include "NatNetTypes.h"
#include "NatNetClient.h"
// #include "../test/util/NatNetClient.h"

namespace natnet {

class Client: public huron::Emitter {
 public:
  static NAN_MODULE_INIT(Init);
  static NAN_METHOD(New);

  static NAN_METHOD(Initialize);
  static NAN_METHOD(Uninitialize);

  static NAN_PROPERTY_GETTER(GetType);
  static NAN_PROPERTY_GETTER(GetConnected);
  static NAN_PROPERTY_GETTER(GetServerDescription);
  static NAN_PROPERTY_GETTER(GetDataDescriptions);

 private:
   explicit Client(const std::string type = "unicast");
  ~Client();

  ConnectionType type_;
  NatNetClient* client_;
  bool connected_;

  static Nan::Persistent<v8::FunctionTemplate> constructor;
};

struct FrameUserData {
  v8::Isolate* isolate;
  Client* client;
};

} // namespace natnet

#endif
