#ifndef NATNET_CONVERTER_H
#define NATNET_CONVERTER_H

#include <nan.h>
#include <native_huron/dictionary.h>
#include <native_huron/converter.h>

#include "NatNetTypes.h"

namespace natnet {

class Converter {
 public:
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sServerDescription*);

  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sMarkerSetDescription*);

  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sFrameOfMocapData*);
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sFrameOfMocapData*,
    huron::Dictionary& result);

  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sMarkerSetData*);

  static v8::Local<v8::Value> ToV8(v8::Isolate*, const MarkerData);
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const size_t,
    const MarkerData*);

  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sMarker*);
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const size_t,
    const sMarker*);
  
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sRigidBodyData*);
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const size_t,
    const sRigidBodyData*);

  static v8::Local<v8::Value> ToV8(v8::Isolate*, const sSkeletonData*);
  static v8::Local<v8::Value> ToV8(v8::Isolate*, const size_t,
    const sSkeletonData*);
};

} // namespace natnet

#endif
